Search documentation of wx

# View Source wxListBox (wx v2.4.2)

Functions for wxListBox class

A listbox is used to select one or more of a list of strings.

The strings are displayed in a scrolling box, with the selected string(s) marked in reverse video. A listbox can be single selection (if an item is selected, the previous selection is removed) or multiple selection (clicking an item toggles the item on or off independently of other selections).

List box elements are numbered from zero and while the maximal number of elements is unlimited, it is usually better to use a virtual control, not requiring to add all the items to it at once, such as `wxDataViewCtrl` (not implemented in wx) or `wxListCtrl` with `wxLC_VIRTUAL` style, once more than a few hundreds items need to be displayed because this control is not optimized, neither from performance nor from user interface point of view, for large number of items.

Notice that the list box doesn't support control characters other than `TAB`.

Styles

This class supports the following styles:

See: `wxEditableListBox` (not implemented in wx), `wxChoice`, `wxComboBox`, `wxListCtrl`, `wxCommandEvent`

This class is derived (and can use functions) from: `wxControlWithItems` `wxControl` `wxWindow` `wxEvtHandler`

wxWidgets docs: wxListBox

## Events

Event types emitted from this class: `command_listbox_selected`, `command_listbox_doubleclicked`

# Summary

## Types

wxListBox()

## Functions

create(This, Parent, Id, Pos, Size, Choices)
create/7
deselect(This, N)

Deselects an item in the list box.

destroy(This)

Destructor, destroying the list box.

getSelections(This)

Fill an array of ints with the positions of the currently selected items.

hitTest(This, Point)

Returns the item located at `point`, or `wxNOT_FOUND` if there is no item located at `point`.

hitTest(This, X, Y)

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

insertItems(This, Items, Pos)

Insert the given number of strings before the specified position.

isSelected(This, N)

Determines whether an item is selected.

new()

Default constructor.

new(Parent, Id)
new/3

Constructor, creating and showing a list box.

set(This, Items)

Replaces the current control contents with the given items.

setFirstItem/2

Set the specified item to be the first visible item.

# Types

Link to this type

# wxListBox()

View Source

    -type wxListBox() :: wx:wx_object().

# Functions

Link to this function

# create(This, Parent, Id, Pos, Size, Choices)

View Source

    -spec create(This, Parent, Id, Pos, Size, Choices) -> boolean()
                    when
                        This :: wxListBox(),
                        Parent :: wxWindow:wxWindow(),
                        Id :: integer(),
                        Pos :: {X :: integer(), Y :: integer()},
                        Size :: {W :: integer(), H :: integer()},
                        Choices :: [unicode:chardata()].

Link to this function

# create/7

View Source

    -spec create(This, Parent, Id, Pos, Size, Choices, [Option]) -> boolean()
                    when
                        This :: wxListBox(),
                        Parent :: wxWindow:wxWindow(),
                        Id :: integer(),
                        Pos :: {X :: integer(), Y :: integer()},
                        Size :: {W :: integer(), H :: integer()},
                        Choices :: [unicode:chardata()],
                        Option :: {style, integer()} | {validator, wx:wx_object()}.

Link to this function

# deselect(This, N)

View Source

    -spec deselect(This, N) -> ok when This :: wxListBox(), N :: integer().

Deselects an item in the list box.

Remark: This applies to multiple selection listboxes only.

Link to this function

# destroy(This)

View Source

    -spec destroy(This :: wxListBox()) -> ok.

Destructor, destroying the list box.

Link to this function

# getSelections(This)

View Source

    -spec getSelections(This) -> Result
                           when Result :: {Res :: integer(), Selections :: [integer()]}, This :: wxListBox().

Fill an array of ints with the positions of the currently selected items.

Return: The number of selections.

Remark: Use this with a multiple selection listbox.

See: `wxControlWithItems:getSelection/1`, `wxControlWithItems:getStringSelection/1`, `wxControlWithItems:setSelection/2`

Link to this function

# hitTest(This, Point)

View Source

    -spec hitTest(This, Point) -> integer()
                     when This :: wxListBox(), Point :: {X :: integer(), Y :: integer()}.

Returns the item located at `point`, or `wxNOT_FOUND` if there is no item located at `point`.

It is currently implemented for wxMSW, wxMac and wxGTK2 ports.

Return: Item located at point, or wxNOT_FOUND if unimplemented or the item does not exist.

Since: 2.7.0

Link to this function

# hitTest(This, X, Y)

View Source

    -spec hitTest(This, X, Y) -> integer() when This :: wxListBox(), X :: integer(), Y :: integer().

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Link to this function

# insertItems(This, Items, Pos)

View Source

    -spec insertItems(This, Items, Pos) -> ok
                         when This :: wxListBox(), Items :: [unicode:chardata()], Pos :: integer().

Insert the given number of strings before the specified position.

Link to this function

# isSelected(This, N)

View Source

    -spec isSelected(This, N) -> boolean() when This :: wxListBox(), N :: integer().

Determines whether an item is selected.

Return: true if the given item is selected, false otherwise.

Link to this function

# new()

View Source

    -spec new() -> wxListBox().

Default constructor.

Link to this function

# new(Parent, Id)

View Source

    -spec new(Parent, Id) -> wxListBox() when Parent :: wxWindow:wxWindow(), Id :: integer().

Link to this function

# new/3

View Source

    -spec new(Parent, Id, [Option]) -> wxListBox()
                 when
                     Parent :: wxWindow:wxWindow(),
                     Id :: integer(),
                     Option ::
                         {pos, {X :: integer(), Y :: integer()}} |
                         {size, {W :: integer(), H :: integer()}} |
                         {choices, [unicode:chardata()]} |
                         {style, integer()} |
                         {validator, wx:wx_object()}.

Constructor, creating and showing a list box.

See the other `new/3` constructor; the only difference is that this overload takes a `wxArrayString` (not implemented in wx) instead of a pointer to an array of `wxString` (not implemented in wx).

Link to this function

# set(This, Items)

View Source

    -spec set(This, Items) -> ok when This :: wxListBox(), Items :: [unicode:chardata()].

Replaces the current control contents with the given items.

Notice that calling this method is usually much faster than appending them one by one if you need to add a lot of items.

Link to this function

# setFirstItem/2

View Source

    -spec setFirstItem(This, N) -> ok when This :: wxListBox(), N :: integer();
                      (This, String) -> ok when This :: wxListBox(), String :: unicode:chardata().

Set the specified item to be the first visible item.